<script lang="ts">
  import type { RouteAndParams } from 'typescript-router'
  import { router } from 'src/components/router'
  import type { AppRouter } from 'src/components/router'

  export let ref: string | undefined = undefined

  export let route: RouteAndParams<AppRouter>

  /** Whether the current history entry should be replaced instead of a new entry being created. */
  export let replace: boolean = false

  /** By default, the navigation occurs on mousedown, which feels faster than waiting for a full click. */
  export let navigateOnClick: boolean = false

  $: href = router.link(route[0], route[1])

  let preventClickDefault = false

  function onMouseDown(evt: DOM.MouseEvent<HTMLAnchorElement>) {
    if (navigateOnClick) return

    preventClickDefault = false

    const navigated = maybeNavigate(evt)
    if (navigated) {
      preventClickDefault = true
    }
  }

  function onClick(evt: DOM.MouseEvent<HTMLAnchorElement>) {
    if (navigateOnClick) {
      if (maybeNavigate(evt)) evt.preventDefault()
      return
    }

    if (preventClickDefault) {
      preventClickDefault = false
      evt.preventDefault()
    }
  }

  function maybeNavigate(evt: DOM.MouseEvent<HTMLAnchorElement>) {
    const isModifiedEvent = Boolean(
      evt.metaKey || evt.altKey || evt.ctrlKey || evt.shiftKey
    )

    const isSelfTarget =
      !evt.target || !evt.currentTarget.target || evt.currentTarget.target === '_self'

    if (
      isSelfTarget && // Ignore everything but links with target self
      evt.button === 0 && // ignore everything but left clicks
      !isModifiedEvent // ignore clicks with modifier keys
    ) {
      if (replace) router.replace(route[0], route[1])
      else router.push(route[0], route[1])

      return true
    }

    return false
  }
</script>

<a data-ref={ref} {href} on:mousedown={onMouseDown} on:click={onClick}>
  <slot />
</a>
